\documentclass[10pt,a4paper]{report}
\usepackage[top=3cm, bottom=2.5cm, left=3cm, right=2.5cm] {geometry}
\usepackage {bsymb,b2latex}
\usepackage[utf8]{inputenc}
\usepackage{fancyhdr,lastpage,color}
\lhead{\rm An Event-B Specification of algorithm}
\rhead {\rm Page \thepage~of \pageref{LastPage}}
\lfoot{}\cfoot{}\rfoot{}
\pagestyle{fancy}
%---------------------------------------------------------
\begin{document}
\thispagestyle{empty}
\begin{description}
\BTitle{algorithm}{6Jul2014}{00:26:50 AM}
\MACHINE{algorithm}
\SEES{context0}
\VARIABLES
	\begin{description}
		\Item{ l }
		\Item{ m }
		\Item{ i }
	\end{description}

	\INITIALISATION
		\begin{description}
		\BeginAct
			\begin{description}
			\nItem{ act5 }{ l :=  l0 }
			\nItem{ act6 }{ m :\in  \nat  }
			\nItem{ act7 }{ i :\in  0\upto n }
			\end{description}
		\EndAct
		\end{description}
	\EVT {al0l1}
		\begin{description}
		\WhenGrd
			\begin{description}
			\nItem{ grd1 }{ l=l0 }
			\end{description}
		\ThenAct
			\begin{description}
			\nItem{ act4 }{ l :=  l1 }
			\nItem{ act5 }{ m:=  f(0) }
			\end{description}
		\EndAct
		\end{description}
	\EVT {al1l2}
		\begin{description}
		\WhenGrd
			\begin{description}
			\nItem{ grd1 }{ l=l1 }
			\end{description}
		\ThenAct
			\begin{description}
			\nItem{ act1 }{ l:= l2 }
			\nItem{ act2 }{ i:= 1 }
			\end{description}
		\EndAct
		\end{description}
	\EVT {al2l3}
		\begin{description}
		\WhenGrd
			\begin{description}
			\nItem{ grd1 }{ l=l2 }
			\nItem{ grd2 }{ i <  n }
			\end{description}
		\ThenAct
			\begin{description}
			\nItem{ act1 }{ l:= l3 }
			\end{description}
		\EndAct
		\end{description}

	\EVT {am3l4}
		\begin{description}
		\WhenGrd
			\begin{description}
			\nItem{ grd1 }{ l=l3 }
			\nItem{ grd2 }{ f(i)> m }
			\end{description}
		\ThenAct
			\begin{description}
			\nItem{ act1 }{ l:= l4 }
			\end{description}
		\EndAct
		\end{description}

	\EVT {al4l5}
		\begin{description}
		\WhenGrd
			\begin{description}
			\nItem{ grd1 }{ l=l4 }
			\end{description}
		\ThenAct
			\begin{description}
			\nItem{ act1 }{ l :=  l5 }
			\nItem{ act2 }{ m:= f(i) }
			\end{description}
		\EndAct
		\end{description}
	\EVT {el5l6}
		\begin{description}
		\WhenGrd
			\begin{description}
			\nItem{ grd1 }{ l=l5 }
			\end{description}
		\ThenAct
			\begin{description}
			\nItem{ act1 }{ l:= l6 }
			\end{description}
		\EndAct
		\end{description}
	\EVT {al6l7}
		\begin{description}
		\WhenGrd
			\begin{description}
			\nItem{ grd1 }{ l=l6 }
			\end{description}
		\ThenAct
			\begin{description}
			\nItem{ act1 }{ l:= l7 }
			\nItem{ act2 }{ i:= i+1 }
			\end{description}
		\EndAct
		\end{description}
	\EVT {el7l3}
		\begin{description}
		\WhenGrd
			\begin{description}
			\nItem{ grd1 }{ l=l7 }
			\nItem{ grd2 }{ i <  n }
			\end{description}
		\ThenAct
			\begin{description}
			\nItem{ act1 }{ l:= l3 }
			\end{description}
		\EndAct
		\end{description}
	\EVT {el3l8}
		\begin{description}
		\WhenGrd
			\begin{description}
			\nItem{ grd1 }{ l=l3 }
			\nItem{ grd2 }{ i \geq  n }
			\end{description}
		\ThenAct
			\begin{description}
			\nItem{ act1 }{ l:= l8 }
			\end{description}
		\EndAct
		\end{description}
\END
\end{description}
\end{document}
